library(pwr)

#2 ֐power.t.tomorrow̒`
power.t.tomorrow <- function(ʗ ,="two.sided",
                             LӐ=c(.05, .01, .001),
                             =c(.7,.8,.9,.95)   ){       
   noy<-length(LӐ); nok<-length()
  ΉȂ<-Ή<-matrix(0,noy,nok)
  ii<-0
  rownames(ΉȂ)<-rownames(Ή)<-LӐ
  colnames(ΉȂ)<-colnames(Ή)<-
  for (i in LӐ){   ii<-ii+1; jj<-0
     for (j in ){    jj<-jj+1
      ΉȂ[ii,jj]<- ceiling(power.t.test(power=j, delta=ʗ, 
        sig.level=i, type='two.sample', strict=T, alternative=)$n)
      Ή[ii,jj]<- ceiling(power.t.test(power=j, delta=ʗ, 
        sig.level=i, type='paired', strict=T, alternative=)$n)
  }}
  cat("ʗ=",ʗ,"Б=",,"\n")
  cat("\n")
  cat("ΉȂ̎1̌Q̕W{","\n")
  print(ΉȂ)
  cat("\n")
  cat("Ή̎1̌Q̕W{","\n")
  print(Ή)
}

#3 ւ̕
power.p.tomorrow <- function(ʗ,
                             LӐ=c(.05, .01, .001),
                             =c(.7,.8,.9,.95)   ){       
   noy<-length(LӐ); nok<-length()
  䗦<-matrix(0,noy,nok)
  ii<-0
  rownames(䗦)<-LӐ
  colnames(䗦)<-
  for (i in LӐ){   ii<-ii+1; jj<-0
     for (j in ){    jj<-jj+1
      䗦[ii,jj]<- ceiling(pwr.2p.test(h=ʗ, power=j, sig.level=i)$n)
  }}
  print(䗦)
}

#4 
###################### ͂̑Oɓǂݍ #########################
##### O͂̊̕֐(power.chisq.pre)
power.chisq.pre <- function(ʗ=c(0.1, 0.3, 0.5), Rx, LӐ=0.05, =0.8, roundup=TRUE){
jizenN<-matrix(1,1,length(ʗ))
j <-0 
for (i in ʗ){
	j <- j+1
	jizenN[j]<-(pwr.chisq.test(w=i,df=Rx,sig.level=LӐ,power= )$N)
	}
colnames(jizenN)<-ʗ;row.names(jizenN)<-"N"
if (roundup==TRUE){
	print(ceiling(jizenN))
	}else{
	print(jizenN)
	}
}


##### ւ͂̊̕֐(power.chisq.tomorrow)
power.chisq.tomorrow<-function(ʗ, Rx, LӐ=c(.05,.01,.001), =c(0.7,0.8,0.9,0.95), roundup=TRUE){
needN<-matrix(0,nrow=length(sig.level),ncol=length(power))
for (i in 1:length(sig.level)){
	for (j in 1:length(power)){
		tomorrow<-pwr.chisq.test(w=ʗ,df=Rx,sig.level=LӐ[i],power=[j])
		needN[i,j]<-tomorrow$N
	}
}
row.names(needN)<-sig.level; colnames(needN)<-power
if (roundup==TRUE){
	print(ceiling(needN))
	}else{
	print(needN)
	}
}

#5 
#֐power.r.tomorrow̒`
power.r.tomorrow <- function(ʗ ,
                             LӐ=c(.05, .01, .001),
                             =c(.7,.8,.9,.95)   ){          
   noy<-length(LӐ); nok<-length()
  W{<-matrix(0,noy,nok)
  ii<-0
  rownames(W{)<-LӐ
  colnames(W{)<-
  for (i in LӐ){   ii<-ii+1; jj<-0
     for (j in ){    jj<-jj+1
      W{[ii,jj]<- ceiling(pwr.r.test(power=j, r=ʗ, 
        sig.level=i)$n)
  }}
  cat("ʗ=",ʗ,"\n")
  cat("\n")
  cat("ւ́̕iKvW{j","\n")
  print(W{)
}

#6 
##ւ̕
#֐power.f.tomorrow̒`
power.f.tomorrow <- function(ʗ, Q̐,
                             LӐ=c(.05, .01, .001),
                             =c(.7,.8,.9,.95)   ){       
   noy<-length(LӐ); nok<-length()
  W{<-matrix(0,noy,nok)
  ii<-0
  rownames(W{)<-LӐ
  colnames(W{)<-
  for (i in LӐ){   ii<-ii+1; jj<-0
     for (j in ){    jj<-jj+1
      W{[ii,jj]<- ceiling(pwr.anova.test(f=ʗ, k=Q̐, 
	     n=NULL, power=j, sig.level=i)$n)
  }}
  cat("ʗ=",ʗ,"\n")
  cat("\n")
  cat("vU͂1̌Q̕W{","\n")
  print(W{)
}

#7 
#ւ̕
#֐power.f2.tomorrow̒`
power.f2.tomorrow <- function(f2, u, w=0, 
                             sig.level=c(.05, .01, .001),
                             power=c(.7,.8,.9,.95)){  
   noy<-length(sig.level); nok<-length(power)
  kekka<-matrix(0,noy,nok)
  ii<-0
  rownames(kekka)<-sig.level
  colnames(kekka)<-power
  for (i in sig.level){   ii<-ii+1; jj<-0
     for (j in power){    jj<-jj+1
      kekka[ii,jj]<- ceiling(pwr.f2.test(u=u, power=j, f2=f2, 
        sig.level=i)$v + w + u + 1)
  }}
  cat("ʗ=",f2,"u=",u,"w=",w,"\n")
  cat("\n")
  print(kekka)
}

#8 
#Oׂ͂̈̊̕֐power.anova.pre
power.anova.pre<-function(f=c(0.1,0.25,0.4),df,cell,power=0.8,roundup=TRUE,sig.level=0.05){
    twoanova<-function(df,f,cell,power,sig.level){
         library(pwr)
         n<-pwr.anova.test(power=power,k=df+1,n=,f=f,sig.level=sig.level)$n    
         pcn<-function(z,x,y){((z-1)*(x+1)/(y))+1}
         en<-pcn(z=n,x=df,y=cell)
         return(en)       
         }
         result<-numeric(length(f))
         for(k in 1:length(f)){
         result[k]<-twoanova(df=df,cell=cell,f=f[k],power=power,sig.level=sig.level)
         }
         ifelse(roundup==TRUE,totalsizeup<-t(ceiling(result))*cell,totalsizeup<-t(result)*cell)
@@@@ ifelse(roundup==TRUE,cellsize<-t(ceiling(result)),cellsize<-t(result))
         res5<-rbind(cellsize,totalsizeup)
         colnames(res5)<-f
         rownames(res5)<-c("ZƂ̕W{","SW{")  
 return(res5)
 }

#ւׂ͂̈̊̕֐power.anova.tomorrow
power.anova.tomorrow <- function(f,df,cell,roundup=TRUE,sig.level=c(.05, .01, .001),
        power=c(.7,.8,.9,.95)){       
       pwr.anova.pre<-function(f,df,cell,power,roundup,sig.level){
        twoanova<-function(df,f,cell,power,sig.level){
         library(pwr)
         n<-pwr.anova.test(power=power,k=df+1,n=,f=f,sig.level=sig.level)$n    
         pcn<-function(z,x,y){((z-1)*(x+1)/(y))+1}
         en<-pcn(z=n,x=df,y=cell)
         return(en)       
         }
         result<-numeric(length(f))
         for(k in 1:length(f)){
         result[k]<-twoanova(df=df,cell=cell,f=f[k],power=power,sig.level=sig.level)
         }
         ifelse(roundup==TRUE,totalsizeup<-t(ceiling(result))*cell,totalsizeup<-t(result)*cell)
         ifelse(roundup==TRUE,cellsize<-t(ceiling(result)),cellsize<-t(result))
         res5<-rbind(cellsize,totalsizeup)
         return(res5)
         }
           noy<-length(sig.level); nok<-length(power)
           ares<-ares2<-matrix(0,noy,nok)
           ii<-0
           rownames(ares)<-rownames(ares2)<-sig.level
           colnames(ares)<-colnames(ares2)<-power
  for (i in sig.level){   ii<-ii+1; jj<-0
     for (j in power){    jj<-jj+1
       ares[ii,jj]<- pwr.anova.pre(power=j,f,df,cell,roundup,sig.level=i)[1,]
       ares2[ii,jj]<-pwr.anova.pre(power=j,f,df,cell,roundup,sig.level=i)[2,]
             }}
    res6<-list(ZƂ̕W{=ares,SW{=ares2)
    return(res6)
 }

#̕
#W{ׂ͂̈̏CW{߂֐
nprime<-function(df1,df2){((df2)/(df1+1))+1}

#W{ʗʂ߂֐
effect<-function(df1,df2,F){sqrt(((df1*F)/(df1*F+df2))/(1-((df1*F)/(df1*F+df2))))}

#9 
#9.2.4
#֐power.block.pre̒`
power.block.pre <- function(f=c(0.02,0.15,0.35),dfa,dfb,power=0.8,sig.level=0.05){
          library(pwr)
          result <- numeric(length(f))
          for(i in 1:length(f)){
            result[i] <- (pwr.f2.test(u=dfa,f2=f[i],sig.level=sig.level,power=power)$v+dfa+dfb+1) / (dfa+1)}
            result2 <- ceiling(result)
            cat("ʗ",f,"ɑ΂鐅̕W{","\n")
            print(result2)}

#9.2.6
#֐power.f2.tomorrow2̒`
power.f2.tomorrow2 <- function(f2, dfa, dfb, 
                             sig.level=c(.05, .01, .001),
                             power=c(.7,.8,.9,.95)){  
  library(pwr)
  noy<-length(sig.level); nok<-length(power)
  kekka<-matrix(0,noy,nok)
  ii<-0
  rownames(kekka)<-sig.level
  colnames(kekka)<-power
  for (i in sig.level){   ii<-ii+1; jj<-0
     for (j in power){    jj<-jj+1
      kekka[ii,jj]<- ceiling((pwr.f2.test(u=dfa, power=j, f2=f2, sig.level=i)$v + dfb + dfa + 1)/(dfa+1))
  }}
  cat("ʗ=",f2,"dfa=",dfa,"dfb=",dfb,"\n")
  cat("̕W{","\n")
  cat("\n")
  print(kekka)
}

#9.4
#֐power.cov.pre̒`
power.cov.pre <- function(f=c(0.02,0.15,0.35),dfa,dfc,power=0.8,sig.level=0.05){
          library(pwr)
          result <- numeric(length(f))
          for(i in 1:length(f)){
            result[i] <- (pwr.f2.test(u=dfa,f2=f[i],sig.level=sig.level,power=power)$v+dfa+dfc+1) / (dfa+1)}
            result2 <- ceiling(result)
            cat("ʗ",f,"ɑ΂鐅̕W{","\n")
            print(result2)}

#9.4.3
#֐power.cov.tomorrow̒`
power.cov.tomorrow <- function(f2, dfa, dfc, 
                             sig.level=c(.05, .01, .001),
                             power=c(.7,.8,.9,.95)){  
  library(pwr)
  noy<-length(sig.level); nok<-length(power)
  kekka<-matrix(0,noy,nok)
  ii<-0
  rownames(kekka)<-sig.level
  colnames(kekka)<-power
  for (i in sig.level){   ii<-ii+1; jj<-0
     for (j in power){    jj<-jj+1
      kekka[ii,jj]<- ceiling((pwr.f2.test(u=dfa, power=j, f2=f2, sig.level=i)$v + dfc + dfa + 1)/(dfa+1))
  }}
  cat("ʗ=",f2,"dfa=",dfa,"dfc=",dfc,"\n")
  cat("̕W{","\n")
  cat("\n")
  print(kekka)
}
